// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	dal "LAPP_LF_MOM_BACKEND/dao/log"
	"LAPP_LF_MOM_BACKEND/db"
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/log"
	model "LAPP_LF_MOM_BACKEND/models/log"
	"LAPP_LF_MOM_BACKEND/web/models"
)

/******************************************************************************
 *
 * @Description              : PackTemplateItemlst的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
var DefaultConditionOfPackTemplateItemlst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackTemplateItemlst_PackTemplateId.UrlParameterName: grmi.NewConditionItem(meta.PackTemplateItemlst_PackTemplateId, grmi.Equal, true),
		meta.PackTemplateItemlst_Pos.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemlst_Pos, grmi.Equal, true),
		meta.PackTemplateItemlst_PosCode.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemlst_PosCode, grmi.Equal, false),
		meta.PackTemplateItemlst_MaterialId.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_MaterialId, grmi.Equal, false),
		meta.PackTemplateItemlst_Seq.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemlst_Seq, grmi.Equal, false),
		meta.PackTemplateItemlst_PlanQty.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemlst_PlanQty, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustC1.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustC1, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustC2.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustC2, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustI1.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustI1, grmi.Equal, false),
		meta.PackTemplateItemlst_PKTMPICustI2.UrlParameterName:   grmi.NewConditionItem(meta.PackTemplateItemlst_PKTMPICustI2, grmi.Equal, false),
		meta.PackTemplateItemlst_LastModify.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_LastModify, grmi.Approximate, false),
		meta.PackTemplateItemlst_LastUser.UrlParameterName:       grmi.NewConditionItem(meta.PackTemplateItemlst_LastUser, grmi.Equal, false),
		meta.PackTemplateItemlst_CreateTime.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemlst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : PackTemplateItemlst的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
var DefaultConditionOfPackTemplateItemlstAndPaging = grmi.NewCondition(
	DefaultConditionOfPackTemplateItemlst.Items,
	grmi.NewPaging(),
)

/******************************************************************************
*
* @Struct Name              : PackTemplateItemlstServiceImplement
*-----------------------------------------------------------------------------
*
* @Description              : PackTemplateItemlst的服务实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-03-23 10:43:27
*
******************************************************************************/
type PackTemplateItemlstServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewPackTemplateItemlstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个PackTemplateItemlstDAOImplement实例
 *
 * @Return Value             : PackTemplateItemlstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
func NewPackTemplateItemlstServiceImplement() *PackTemplateItemlstServiceImplement {
	return &PackTemplateItemlstServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.InsertOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) InsertOne(user *models.Usertab, entity *model.PackTemplateItemlst) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "InsertOnePackTemplateItemlst", "插入一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.DeleteOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) DeleteOne(user *models.Usertab, packTemplateId string, pos int) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "DeleteOnePackTemplateItemlst", "删除一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.SelectOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) SelectOne(user *models.Usertab, packTemplateId string, pos int) (*model.PackTemplateItemlst, error) {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "SelectOnePackTemplateItemlst", "查询一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.UpdateOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) UpdateOne(user *models.Usertab, entity *model.PackTemplateItemlst) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "UpdateOnePackTemplateItemlst", "修改一个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.Insert
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) Insert(user *models.Usertab, entities *[]model.PackTemplateItemlst) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "InsertPackTemplateItemlst", "插入多个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.Delete
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) Delete(user *models.Usertab, entities *[]model.PackTemplateItemlst) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "DeletePackTemplateItemlst", "删除多个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.Select
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) (interface{}, error) {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "SelectPackTemplateItemlst", "查询PackTemplateItemlst")

	condition := DefaultConditionOfPackTemplateItemlstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/services/log/PackTemplateItemlstService.Update
 *
 ******************************************************************************/
func (impl *PackTemplateItemlstServiceImplement) Update(user *models.Usertab, entities *[]model.PackTemplateItemlst) error {

	grmi.Log(user, "/services/log/implments/LOG_PackTemplateItemlst.service.impl.go", "UpdatePackTemplateItemlst", "修改多个PackTemplateItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}
